/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __platform_regex_h__
#define __platform_regex_h__

namespace fe
{

extern "C"
{

typedef void* (RegexInitFunction)(const char* a_pattern);
typedef void* (RegexMatchFunction)(void* a_expression,const char* a_candidate);
typedef const char* (RegexResultFunction)(void* a_result,U32 a_index);
typedef const char* (RegexReplaceFunction)(void* a_expression,
		const char* a_candidate,const char* a_replacement);
typedef void (RegexFinishFunction)(void* a_expression);
typedef void (RegexReleaseFunction)(void* a_result);

} /* extern "C" */

class FE_DL_PUBLIC FE_DL_EXPORT Regex
{
	public:
				Regex(const char* a_pattern);
				~Regex(void);
		BWORD	match(const char* a_candidate);
		BWORD	search(const char* a_candidate);
const	char*	replace(const char* a_candidate,const char* a_replacement);
const	char*	result(U32 a_index);

static	void	replaceInitFunction(RegexInitFunction* a_fnInit)
				{	ms_fnInit=a_fnInit; }
static	void	replaceMatchFunction(RegexMatchFunction* a_fnMatch)
				{	ms_fnMatch=a_fnMatch; }
static	void	replaceSearchFunction(RegexMatchFunction* a_fnSearch)
				{	ms_fnSearch=a_fnSearch; }
static	void	replaceResultFunction(RegexResultFunction* a_fnResult)
				{	ms_fnResult=a_fnResult; }
static	void	replaceReplaceFunction(RegexReplaceFunction* a_fnReplace)
				{	ms_fnReplace=a_fnReplace; }
static	void	replaceFinishFunction(RegexFinishFunction* a_fnFinish)
				{	ms_fnFinish=a_fnFinish; }
static	void	replaceReleaseFunction(RegexReleaseFunction* a_fnRelease)
				{	ms_fnRelease=a_fnRelease; }

	private:

static	BWORD	confirm(void);

static	RegexInitFunction*		ms_fnInit;
static	RegexMatchFunction*		ms_fnMatch;
static	RegexMatchFunction*		ms_fnSearch;
static	RegexResultFunction*	ms_fnResult;
static	RegexReplaceFunction*	ms_fnReplace;
static	RegexFinishFunction*	ms_fnFinish;
static	RegexReleaseFunction*	ms_fnRelease;
static	BWORD					ms_checked;

		void*					m_pExpression;
		void*					m_pResult;
};

} /* namespace */

#endif /* __platform_regex_h__ */
